// apprentice.c

#include <ansi.h>

inherit F_CLEAN_UP;

int main(object me, string arg)
{
	object ob, old_app;
	mapping family, skills;
	int i;
	string *skname;

	if( !arg ) return notify_fail("O榡Rapprentice [cancel]|<H>\n");

	if( arg=="cancel" ) {
		old_app = me->query_temp("pending/apprentice");
		if( !objectp(old_app) )
			return notify_fail("A{bèSHvNC\n");
		write("AܥDNQ" + old_app->name() + "vFC\n");
		tell_object(old_app, me->name() + "ܥDNQAvFC\n");
		me->delete_temp("pending/apprentice");
		return 1;
	}

	if( !(ob = present(arg, environment(me)))
	||	!ob->is_character() )
		return notify_fail("AQ֬vS\n");

	if( !living(ob) ) return notify_fail("A" + ob->name() + "˿C\n");

	if( ob==me ) return notify_fail("ۤvvSnDN....LSΡC\n");

	if( me->is_apprentice_of(ob) ) {
		message_vision("$NqqaV$nWYЦwMsDRuvTv\n", me, ob);
		return 1;
	}

	if( !mapp( ob->query("family") ) )
		return notify_fail(ob->name() + "JݩM]S}s߬MvC\n");

	// If the target is willing to recruit us already, we do it.
	if( (object)ob->query_temp("pending/recruit") == me ) {

		if( (string)me->query("family/family_name") != (string)ob->query("family/family_name") ) {
			message_vision(
				"$NMwIqvMJ$nUTT\n\n"
				"$NFUӦV$nqqaWF|TYMsDRuvTv\n\n",
				me, ob);
			me->set("score", 0);
			me->add("betrayer", 1);
		} else
			message_vision(
				"$NMw$nvC\n\n"
				"$NFUӦV$nqqaWF|TYMsDRuvTv\n\n",
				me, ob);

		ob->recruit_apprentice(me);
		ob->delete_temp("pending/recruit");

		tell_object(ob, "ߧAsF@W̤lT\n");
		family = me->query("family");
		printf("߱z%s%sN̤lC\n", me->query("family/family_name"),
			chinese_number( me->query("family/generation")));

		return 1;
	
	} else {

		old_app = me->query_temp("pending/apprentice");
		if( ob==old_app )
			return notify_fail("AQ" + ob->name() + "vMO٨SC\n");
		else if( objectp(old_app) ) {
			write("AܥDNQ" + old_app->name() + "vFC\n");
			tell_object(old_app, me->name() + "ܥDNQAvFC\n");
		}

		message_vision("$NQn$nvC\n", me, ob);
		me->set_temp("pending/apprentice", ob );
		if( userp(ob) ) {
			tell_object(ob, YEL "pGA@N" + me->name() + "̤lM recruit OC\n" NOR);
		} else 
			ob->attempt_apprentice(me);
	
		return 1;
	}
}


int help(object me)
{
        write(@HELP
O榡 : apprentice [cancel]|<H>
 
oӫOAYHvMpG]nA{ܡMN|ߧY
v§M_hn recruit OA̤l~ॿvC

Ъ`NAwgFvMSIqvJOHUMҦޯ|bMåB
|sC

pGAvϥγoӫOM|ܦVvЦwC
 
аѦҬO expellBrecruit
HELP
        );
        return 1;
}
