// liquid.c

#include <dbase.h>
#include <name.h>

void init()
{
	add_action("do_drink", "drink");
	add_action("do_fill", "fill");
}

string extra_long()
{
	int amount, max;
	string str;

	if( amount = query("liquid/remaining") ) {
		max = query("max_liquid");
		if( amount == max )
			str = "̭˺F" + query("liquid/name") + "C\n";
		else if( amount > max/2 )
			str = "̭ˤFCBK" + query("liquid/name") + "C\n";
		else if( amount >= max/3 )
			str = "̭ˤFB" + query("liquid/name") + "C\n";
		else if( amount > max/2 )
			str = "̭ˤFֳ\\" + query("liquid/name") + "C\n";
		return str;
	}
	else return 0;
}

int do_drink(string arg)
{
	if( !this_object()->id(arg) ) return 0;
	if( this_player()->is_busy() )
		return notify_fail("AW@Ӱʧ@٨SC\n");
	if( !query("liquid/remaining") )
		return notify_fail( name() + (query("liquid/name") ? "wgQܱo@w]ѤF":"OŪC\n"));
	if( (int)this_player()->query("water") >= (int)this_player()->max_water_capacity() )
		return notify_fail("AwgܤӦhFMA]餣U@wFC\n");

	add("liquid/remaining", -1);
	message_vision("$N_" + name() + "BPPaܤFXf" + query("liquid/name")
		+ "C\n", this_player());
	this_player()->add("water", 30);
	if( this_player()->is_fighting() ) this_player()->start_busy(2);
	if( !query("liquid/remaining") )
		write("AwgN" + name() + "̪" + query("liquid/name")
			+ "ܱo@w]ѤFC\n");

	// This allows customization of drinking effect.
	if( query("liquid/drink_func") ) return 1;

	switch(query("liquid/type")) {
		case "alcohol":
			this_player()->apply_condition("drunk",
				(int)this_player()->query_condition("drunk") 
				+ (int)query("liquid/drunk_apply"));
			break;
	}
	
	return 1;
}

int do_fill(string arg)
{
	if( !this_object()->id(arg) ) return 0;
	if( this_player()->is_busy() )
		return notify_fail("AW@Ӱʧ@٨SC\n");
	if( !environment(this_player())->query("resource/water") )
		return notify_fail("ǫSaiHˤC\n");

	if( query("liquid/remaining") )
		message_vision("$NN" + name() + "̳ѤU" + query("liquid/name") + "˱C\n", this_player());
	message_vision("$NN" + name() + "˺MC\n", this_player());

	if( this_player()->is_fighting() ) this_player()->start_busy(2);

	set("liquid/type", "water");
	set("liquid/name", "M");
	set("liquid/remaining", query("max_liquid"));
	set("liquid/drink_func", 0);

	return 1;
}
